# ps2

ps tools that can be used in Linux/MacOS/Windows.

## Install

```shell
pip install ps2
```

## Usage

```shell
    zencore:scripts zencore$ python3 ps2.py --help
    Usage: ps2.py [OPTIONS] [OUTPUT]

    The keywords can be used in output template:

    cmdline
    connections
    cpu_percent
    cpu_times
    create_time
    cwd
    elapsed_time
    environ
    exe
    gids
    memory_full_info
    memory_info
    memory_info_ex
    memory_maps
    memory_percent
    name
    nice
    num_ctx_switches
    num_fds
    num_threads
    open_files
    pid
    ppid
    status
    threads
    uids
    username

    The default output template is:

    "{pid}\t{name}"

    Options:
    --help  Show this message and exit.
```

## Example 1

By default, ps2 show pid and name.

```shell
    zencore:scripts zencore$ ps2
    0	kernel_task
    89	loginwindow
    282	cfprefsd
    283	distnoted
    287	lsd
    306	UserEventAgent
    311	CommCenter
    312	trustd
    313	sharedfilelistd
    315	Terminal
    ...
```


## Example 2

You can customize the output template, there are many KEYWORDS provided for you to use.

```shell
    zencore:scripts zencore$ ps2 '{pid}\t{elapsed_time}\t{cmdline}'
    0	682055.9033548832	
    89	682043.2770848274	/System/Library/CoreServices/loginwindow.app/Contents/MacOS/loginwindow console
    282	681934.4019351006	/usr/sbin/cfprefsd agent
    283	681934.2526762486	/usr/sbin/distnoted agent
    287	681933.4957187176	/usr/libexec/lsd
    306	681855.2815728188	/usr/libexec/UserEventAgent '(Aqua)'
    311	681855.1821689606	/System/Library/Frameworks/CoreTelephony.framework/Support/CommCenter -L
    312	681855.1382620335	/usr/libexec/trustd --agent
    313	681855.0924699306	/System/Library/CoreServices/sharedfilelistd
    315	681854.9572939873	/Applications/Utilities/Terminal.app/Contents/MacOS/Terminal -psn_0_69649
```


## Releases

### 0.2.0 2019/12/06

- Fix package structure, remove src folder and put ps.py at the root of project folder.
- Change long description format from .rst to .md.

### 0.1.3 2018/04/18

- First stable release.
